# Class Codons

java.lang.Object
jebl.evolution.sequences.Codons

public final class Codons extends Object

Version:
  $Id: Codons.java 744 2007-07-30 02:57:11Z twobeers $
Author:
  Andrew Rambaut, Alexei Drummond

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`CANONICAL_STATE_COUNT`
`static final CodonState[]`
`CANONICAL_STATES`
`static final CodonState`
`GAP_STATE`
`static final String`
`NAME`
`static final int`
`STATE_COUNT`
`static final CodonState[]`
`STATES`
`static final CodonState`
`UNKNOWN_STATE`

## Constructor Summary

Constructors
Constructor
Description
`Codons()`

## Method Summary

Modifier and Type
Method
Description
`static int`
`getCanonicalStateCount()`
`static List<State>`
`getCanonicalStates()`
`static CodonState`
`getGapState()`
`static CodonState`
`getState(int index)`
`static CodonState`
`getState(String code)`
Gets the state object for the given code.
`static CodonState`
`getState(NucleotideState nucleotide1, NucleotideState nucleotide2, NucleotideState nucleotide3)`
`static int`
`getStateCount()`
`static List<State>`
`getStates()`
`static CodonState`
`getUnknownState()`
`static boolean`
`isGap(CodonState state)`
`static boolean`
`isUnknown(CodonState state)`
`static NucleotideState[]`
`toNucleotides(CodonState state)`
`static NucleotideState[]`
`toNucleotides(State[] states)`
`static CodonState[]`
`toStateArray(byte[] indexArray)`
`static CodonState[]`
`toStateArray(String sequenceString)`

### Methods inherited from class Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### NAME

public static final String NAME

See Also:
  - Constant Field Values

### CANONICAL_STATE_COUNT

public static final int CANONICAL_STATE_COUNT

See Also:
  - Constant Field Values

### STATE_COUNT

public static final int STATE_COUNT

See Also:
  - Constant Field Values

### CANONICAL_STATES

public static final CodonState[] CANONICAL_STATES

### STATES

public static final CodonState[] STATES

### UNKNOWN_STATE

public static final CodonState UNKNOWN_STATE

### GAP_STATE

public static final CodonState GAP_STATE

## Constructor Details

### Codons

public Codons()

## Method Details

### getStateCount

public static int getStateCount()

### getStates

public static List<State> getStates()

### getCanonicalStateCount

public static int getCanonicalStateCount()

### getCanonicalStates

public static List<State> getCanonicalStates()

### getState

public static CodonState getState(NucleotideState nucleotide1, NucleotideState nucleotide2, NucleotideState nucleotide3)

### getState

public static CodonState getState(String code)
Gets the state object for the given code. Returns null if the code is illegal or contains ambiguous nucleotides.

Parameters:
  `code` - a three-character string of non-ambiguous nucleotides in uppercase
Returns:
  the state

### getState

public static CodonState getState(int index)

### getUnknownState

public static CodonState getUnknownState()

### getGapState

public static CodonState getGapState()

### isUnknown

public static boolean isUnknown(CodonState state)

### isGap

public static boolean isGap(CodonState state)

### toNucleotides

public static NucleotideState[] toNucleotides(State[] states)

### toNucleotides

public static NucleotideState[] toNucleotides(CodonState state)

### toStateArray

public static CodonState[] toStateArray(String sequenceString)

### toStateArray

public static CodonState[] toStateArray(byte[] indexArray)